package space.kklochko.jpa_hospital_example.db.repositories;

import jakarta.persistence.EntityManager;
import jakarta.persistence.TypedQuery;
import space.kklochko.jpa_hospital_example.db.repositories.blocks.TransactionalInsert;
import space.kklochko.jpa_hospital_example.db.repositories.blocks.TransactionalRemove;
import space.kklochko.jpa_hospital_example.db.repositories.blocks.TransactionalUpdate;
import space.kklochko.jpa_hospital_example.models.Patient;

import java.util.ArrayList;
import java.util.UUID;

public class PatientRepository extends AbstractRepository<Patient> {
    public PatientRepository(EntityManager manager) {
        super(manager);
    }

    public boolean create(Patient object) {
        TransactionalInsert insert = new TransactionalInsert();

        return insert.run(manager, object);
    }

    public Patient read(UUID id) {
        return manager.find(Patient.class, id);
    }

    public ArrayList<Patient> readAll() {
        TypedQuery<Patient> query = manager.createQuery("SELECT p FROM Patient p", Patient.class);

        return (ArrayList<Patient>) query.getResultList();
    }

    public boolean update(Patient object) {
        TransactionalUpdate update = new TransactionalUpdate();

        return update.run(manager, object);
    }

    public boolean delete(UUID id) {
        Patient object = read(id);

        TransactionalRemove remove = new TransactionalRemove();

        return remove.run(manager, object);
    }
}
